const system = require("../../../system");
const ServiceBase = require("../../sve.base")

/**
 * 订单产品表
 */
class OorderService extends ServiceBase {
  constructor() {
    super("order", ServiceBase.getDaoName(OorderService));

    this.oorderinforegDao = system.getObject("db.order.oorderinforegDao");
    this.oorderdeliverDao = system.getObject("db.order.oorderdeliverDao");
    this.oorderprocessDao = system.getObject("db.order.oorderprocessDao");

    this.osourceDao = system.getObject("db.common.osourceDao");

    this.oproductDao = system.getObject("db.product.oproductDao");
    this.oprocessDao = system.getObject("db.product.oprocessDao");
    this.oproductprocessDao = system.getObject("db.product.oproductprocessDao");
  }

  /**
   *  新增渠道订单
   * @returns {Promise<void>}
   */
  async addSourceOrder(params) {
    // 整理参数
    let order = {
      merchantId: "",
      channelOrderNo: "",
      busi_type: 1,
      busi_id: "",
      price: 0,
    };
    order.productId = Number(params.productId);
    order.sourceId = Number(params.sourceId);
    order.sourceNo = this.trim(params.sourceNo);
    order.notes = this.trim(params.notes);
    order.contactMobile = this.trim(params.contactMobile);

    // 验证来源
    let source = await this.osourceDao.findById(order.sourceId);
    if (!source) {
      return system.getResult(null, "来源错误");
    }

    // 验证产品
    let product = await this.oproductDao.findById(order.productId);
    if (!product) {
      return system.getResult(null, "产品错误");
    }

    // 获取产品状态
    await this.getProductProcessList(productId, );

    // 查询产品订单状态

    // 合并订单状态

    // 开启事务

    // 插入订单数据

    // 插入订单状态数据
  }

  /**
   * 新建进度
   * @param params
   * @returns {Promise<void>}
   */
  async createProcess(params) {
    // 整理参数 变成这个格式，id, status, params

    // 查询订单

    // 找出订单下个状态，于参数订单状态匹配

    // 调用状态func(order, nextObj, params)
  }

  /**
   * 构建产品流程对象
   * @param productPid
   * @param chooseProductIds
   * @returns {Promise<void>}
   */
  async getProductProcessList(productPid, chooseProductIds) {
    // 查询所有产品子项
    let productList = await this.oproductDao.findListByPid(productPid);

    // 根据所选产品id, 查询产品流程
    let productIds = [];
    for (let product of productList) {
      // 过滤未选择产品
      if(product.is_choose && chooseProductIds && chooseProductIds.indexOf(product.id) == -1) {
        continue;
      }
      productIds.push(product.id);
    }
    if (productIds.length == 0) {
      return null;
    }

    // 查询产品流程
    let processMap = await this.oproductprocessDao.findMapByProductProductIds(productPid, productIds);
    let orderProcessList = [];

    for (let productId of productIds) {
      let currentProcess = processMap[productId];
      let orderProcess = {};
      if (processList.length > 0) {
        let lastProcess = productList[processList.length - 1];
      }
    }

  }

  /**
   * 订单管理列表
   * @param {*} params 
   */
  async orders(params){
    let where = {};
    if(params.id){
      where.id = this.trim(params.id);
    }
    if(params.progress){
      where.progress = this.trim(params.progress);
    }
    if(params.beginDate && params.endDate){
      where.beginDate = this.trim(params.beginDate);
      where.endDate = this.trim(params.endDate);
    }
    if(params.deliver_id){
      where.deliver_id = this.trim(params.deliver_id);
    }

    where.currentPage = Number(params.currentPage || 1);
    where.pageSize = Number(params.pageSize || 10);

    where.startRow = (where.currentPage-1)*where.pageSize;
    try {
      let ordersCountRes = await this.dao.ordersCount(where);
      let count = ordersCountRes[0]['orderCount'];
      let rows = await this.dao.findAll(where);
      //格式化订单来源
      this.formateSource(rows);
      //格式化订单产品
      this.formateProduct(rows);
      //格式化交付商
      this.formateDeliver(rows);
      //格式化业务员
      

      let res = {
        count,rows
      };
      return system.getResult(res);
    } catch (error) {
      console.log(error);
      return system.getResult(null,`系统错误 错误信息 ${error}`);
    }
  }

  /**
   * 格式化列表来源数据
   * @param {*} orderList 
   */
  async formateSource(orderList){
    let sourceIdList=[];
    for (let item of orderList) {
      if(item.source_id){
        sourceIdList.push(item.source_id);
      }
    }
    
    let sourceMap = await this.osourceDao.mapByIds(sourceIdList);
    for (let item of orderList) {
      item.osource = sourceMap[item.source_id] || {}
    }
  }

  /**
   * 格式化订单产品
   * @param {*} orderList 
   */
  async formateProduct(orderList){
    let productIdList=[];
    for (let item of orderList) {
      if(item.product_id){
        productIdList.push(item.product_id);
      }
    }
    
    let productMap = await this.oproductDao.mapByIds(productIdList);
    for (let item of productMap) {
      item.oproduct = productMap[item.product_id] || {}
    }
  }

  /**
   * 格式化订单交付商
   * @param {*} orderList 
   */
  async formateDeliver(orderList){
    let deliverIdList=[];
    for (let item of orderList) {
      if(item.deliver_id){
        deliverIdList.push(item.deliver_id);
      }
    }
    
    let deliverMap = await this.oorderdeliverDao.mapByIds(deliverIdList);
    for (let item of deliverMap) {
      item.odeliver = deliverMap[item.deliver_id] || {}
    }
  }


  /**
   * 分配业务员
   * @param {*} params 
   * @id     String  订单ID
   * @bd_id  String  业务员ID
   */
  async assignSalesman (params){
    if(!params.bd_id){
      return system.getResult(null,`参数错误 业务员ID不能为空`);
    }
    try {
      let _order= await this.findById(params.id);
      _order.bd_id = this.trim(params.bd_id);
      let res = await _order.save();
      return system.getResult(res);
    } catch (error) {
      console.log(error);
      return system.getResult(null,`系统错误 错误信息 ${error}`);
    }
  }


  /**
   * 分配交付商
   * @param {*} params 
   * @id  String 订单ID
   * 
   * 
   * 
   */
  async assignDeliver(params){
    //参数验证
    if(!params.id){
      return system.getResult(null, `参数错误 订单ID不能为空`);
    }
    if(!params.deliver_id){
      return system.getResult(null, `参数错误 交付商ID不能为空`);
    }
    if(!params.hasPropertyOne(deliver_divide)){
      return system.getResult(null, `参数错误 订单ID不能为空`);
    }
    //创建orderdeliver记录
    
    //更新oorder订单记录

  }
  



}

module.exports = OorderService;